unit Unit1;

interface

uses
  Windows, Messages, Classes, Graphics, Controls, Forms,
  ExtCtrls, StdCtrls, Buttons, Grids, ComCtrls, ToolWin,
  CheckLst, fspTaskbarMgr, fspTaskbarTabMgr;
  
type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    ListBox1: TListBox;
    TreeView1: TTreeView;
    fspTaskbarTabMgr1: TfspTaskbarTabMgr;
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button5: TButton;
    Image1: TImage;
    MonthCalendar1: TMonthCalendar;
    ProgressBar1: TProgressBar;
    Memo1: TMemo;
    Label1: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    ListView1: TListView;
    Shape1: TShape;
    StringGrid1: TStringGrid;
    UpDown1: TUpDown;
    TrackBar1: TTrackBar;
    Button4: TButton;
    Button6: TButton;
    RichEdit1: TRichEdit;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    SpeedButton1: TSpeedButton;
    BitBtn1: TBitBtn;
    Bevel1: TBevel;
    StaticText1: TStaticText;
    PageControl2: TPageControl;
    TabSheet6: TTabSheet;
    Splitter1: TSplitter;
    Panel4: TPanel;
    CheckListBox1: TCheckListBox;
    TabSheet7: TTabSheet;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    Label2: TLabel;
    Shape2: TShape;
    DateTimePicker1: TDateTimePicker;
    Label4: TLabel;
    ScrollBar1: TScrollBar;
    fspTaskbarMgr1: TfspTaskbarMgr;
    TrackBar2: TTrackBar;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Button7: TButton;
    Label6: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure fspTaskbarTabMgr1NeedIconicBitmap(Sender: TObject;
      Tab: TfspTaskbarTab; Width, Height: Integer; var Bitmap: HBITMAP);
    procedure fspTaskbarTabMgr1NeedIconicLivePreview(Sender: TObject;
      Tab: TfspTaskbarTab; var Bitmap: HBITMAP; var Origin: TPoint);
    procedure fspTaskbarTabMgr1ActivateTab(Sender: TObject;
      Tab: TfspTaskbarTab);
    procedure Button1Click(Sender: TObject);
    procedure fspTaskbarTabMgr1CloseTab(Sender: TObject;
      Tab: TfspTaskbarTab);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;



implementation

uses fspControlsExt,

SysUtils;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
// I tested these third-party controls
  fspPatch_Paint.Add('TAdvOfficePager');
  fspPatch_Paint.Add('TAdvOfficePage');
  fspPatch_Paint.Add('TTBXPanelObject');

  fspTaskbarTabMgr1.AddTab(Pointer(TabSheet1), TabSheet1.Caption);
  fspTaskbarTabMgr1.AddTab(Pointer(TabSheet2), TabSheet2.Caption);
  fspTaskbarTabMgr1.AddTab(Pointer(TabSheet3), TabSheet3.Caption);
  fspTaskbarTabMgr1.AddTab(Pointer(TabSheet4), TabSheet4.Caption);

  fspTaskbarTabMgr1.Active := True;

  PageControl1.ActivePageIndex := 0;
  fspTaskbarTabMgr1.ActivateTab(PageControl1.ActivePageIndex);

  fspTaskBarMgr1.ProgressValueMax := TrackBar2.Max;
  fspTaskBarMgr1.ProgressValue :=  TrackBar2.Position;
end;

procedure TForm1.fspTaskbarTabMgr1NeedIconicBitmap(Sender: TObject;
  Tab: TfspTaskbarTab; Width, Height: Integer; var Bitmap: HBITMAP);
begin
  Bitmap := fspControl2DIBPreview(TTabSheet(Tab.TabData), TTabSheet(Tab.TabData).ClientRect,
                              Width, Height);
end;


procedure TForm1.fspTaskbarTabMgr1NeedIconicLivePreview(Sender: TObject;
  Tab: TfspTaskbarTab; var Bitmap: HBITMAP; var Origin: TPoint);
begin
  Bitmap := fspControl2DIB(TTabSheet(Tab.TabData));
  Origin.x := 0;
  Origin.y := 0;
  Origin :=  TWinControl(Tab.TabData).ClientToScreen(Origin);
  Origin := ScreenToClient(Origin);
end;

procedure TForm1.fspTaskbarTabMgr1ActivateTab(Sender: TObject;
  Tab: TfspTaskbarTab);
begin
  if WindowState = wsMinimized then
    WindowState := wsNormal;
  Show;
  PageControl1.ActivePage := TTabSheet(Tab.TabData);
  fspTaskbarTabMgr1.ActivateTab(PageControl1.ActivePageIndex);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//  if fspTaskbarTabMgr1.TabCount = 1 then Close;
  if PageControl1.ActivePageIndex >=0 then begin
    fspTaskbarTabMgr1.RemoveTab(fspTaskbarTabMgr1.TaskbarTabs[PageControl1.ActivePageIndex]);
    PageControl1.ActivePage.Free;
  end;
end;

procedure TForm1.fspTaskbarTabMgr1CloseTab(Sender: TObject;
  Tab: TfspTaskbarTab);
var
  TabSheet : TTabSheet;
begin
//  if fspTaskbarTabMgr1.TabCount = 1 then Close;
  TabSheet := Tab.TabData;
  fspTaskbarTabMgr1.RemoveTab(fspTaskbarTabMgr1.TaskbarTabs[TabSheet.PageIndex]);
  TabSheet.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if PageControl1.ActivePageIndex < PageControl1.PageCount - 1 then begin
    fspTaskbarTabMgr1.MoveTab(PageControl1.ActivePageIndex, PageControl1.ActivePageIndex + 1);
    PageControl1.ActivePage.PageIndex := PageControl1.ActivePageIndex + 1;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if PageControl1.ActivePageIndex > 0 then begin
    fspTaskbarTabMgr1.MoveTab(PageControl1.ActivePageIndex, PageControl1.ActivePageIndex - 1);
    PageControl1.ActivePage.PageIndex := PageControl1.ActivePageIndex - 1;
  end;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  fspTaskbarTabMgr1.ActivateTab(PageControl1.ActivePageIndex);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  fspTaskbarTabMgr1.InvalidateAllPreviews;
end;

{====================================================}

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  fspTaskBarMgr1.ProgressValue :=  TrackBar2.Position;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  fspTaskBarMgr1.ProgressState := TfspTaskProgressState(ComboBox1.ItemIndex);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  if fspTaskBarMgr1.OverlayIcon.Empty then
    fspTaskbarMgr1.OverlayIcon := Application.Icon
  else
    fspTaskbarMgr1.OverlayIcon := nil;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ProgressBar1.Position := ProgressBar1.Position + 10;
  if ProgressBar1.Position >= 100 then
    ProgressBar1.Position := 0;
  fspTaskbarTabMgr1.InvalidateAllPreviews;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  fspTaskbarMgr1.Active := True;
end;

end.
